image: node


stages:
  - build
  - test
  - deploy staging
  - deploy production
  - production tests


cache:
  key: ${CI_COMMIT_REF_SLUG}
  paths:
    - node_modules/


variables:
  STAGING_DOMAIN: gab-website-staging.surge.sh
  PRODUCTION_DOMAIN: gab-website-production.surge.sh



build website:
  stage: build
  script:
    - echo $CI_COMMIT_SHORT_SHA
    - npm install
    - npm install -g nodemon
    - sed -i "s/%%VERSION%%/$CI_COMMIT_SHORT_SHA/" ./index.html
  artifacts:
    paths:
      - ./index.html


test artifacts:
  image: alpine
  stage: test
  script:
    - grep -q "$CI_COMMIT_SHORT_SHA" ./index.html


test website:
  stage: test
  script:
    - npm install nodemon
    - npm start &
    - sleep 3
    - curl "http://localhost:3000" | tac | tac | grep -q "Hello"


deploy staging:
  stage: deploy staging
  environment:
    name: staging
    url: http://$STAGING_DOMAIN
  script:
    - npm install -global surge
    - surge --project ./ --domain $STAGING_DOMAIN


deploy production:
  stage: deploy production
  environment:
    name: production
    url: http://$PRODUCTION_DOMAIN
  when: manual
  allow_failure: false
  script:
    - npm install -global surge
    - surge --project ./ --domain $PRODUCTION_DOMAIN


production tests:
  image: alpine
  stage: production tests
  script:
    - apk add --no-cache curl
    - curl -s "http://$PRODUCTION_DOMAIN" | grep -q "Demo"
    - curl -s "http://$PRODUCTION_DOMAIN" | grep -q "$CI_COMMIT_SHORT_SHA"